// 001 u_dates
// 01 jun 2003

(*$r+*)

unit u_memo;
  interface
    uses StdCtrls;

    function f_memo_line_index(p_c_memo: tMemo): Integer;
    function f_memo_line(p_c_memo: tMemo): String;
    function f_memo_memory_line(p_c_memo: tMemo): String;
    procedure display_memo_with_index(p_c_memo: tMemo);

    function f_memo_line_of_index(p_c_memo: tMemo; p_text_index: Integer): Integer;

    procedure set_memo_top_line_index(p_c_memo: tMemo; p_top_line_index: Integer);

  implementation
    uses Messages, SysUtils, u_types_constants, u_characters
        , u_c_display;

    function f_memo_line_index(p_c_memo: tMemo): Integer;
      var l_selection_start, l_index: Integer;
          l_the_line: String;
          l_length: Integer;
          l_text: String;
      begin
        Result:= 0;
        with p_c_memo, Lines do
        begin
          l_selection_start:= SelStart;
          l_index:= 1;
          l_text:= Text;
          l_length:= Length(l_text);
          if l_selection_start> l_length
            then l_selection_start:= l_length;

          while l_index< l_selection_start do
          begin
            if l_text[l_index]= k_return
              then begin
                  Inc(l_index, 2);
                  Inc(Result);
                end
              else Inc(l_index);
(*
            l_the_line:= Strings[Result];
            Inc(l_index, Length(l_the_line)+ 2);
            Inc(Result);
*)
          end;
        end; // with p_c_memo
      end; // f_memo_line_index

    function f_memo_line(p_c_memo: tMemo): String;
      var l_memo_line_index: Integer;
      begin
        l_memo_line_index:= f_memo_line_index(p_c_memo);
        display(IntToStr(l_memo_line_index));
        Result:= p_c_memo.Lines[l_memo_line_index];
      end; // f_memo_line

    function f_memo_memory_line(p_c_memo: tMemo): String;
      var l_selection_start, l_index, l_length: Integer;
          l_text: String;
          l_start_index: Integer;
          // l_line_number: Integer;
          l_line_index: Integer;
      begin
        Result:= '';

        with p_c_memo do
        begin
          l_selection_start:= SelStart;

          l_index:= 1;
          l_text:= Text;
          l_length:= Length(l_text);
          l_index:= 1;
          l_start_index:= 1; // l_line_number:= 0;

          while l_index<= l_selection_start do
          begin
            if l_text[l_index]= k_return
              then begin
                 Inc(l_index, 2);
                 l_start_index:= l_index;
                 // Inc(l_line_number);
                end
              else begin
                 Inc(l_index);
               end;
          end;

          // -- get the start of the line
          for l_line_index:= l_start_index to l_index- 1 do
            Result:= Result+ l_text[l_line_index];

          // -- go to the end of the line
          while (l_index<= l_length) and (l_text[l_index]<> k_return) do
          begin
            Result:= Result+ l_text[l_index];
            Inc(l_index);
          end;

        end; // with p_c_memo
      end; // f_memo_memory_line

    procedure display_memo_with_index(p_c_memo: tMemo);
      var l_index, l_length: Integer;
          l_the_line: String;
          l_text: String;
          l_start_index: Integer;
          l_line_number: Integer;
      begin
        with p_c_memo do
        begin
          l_index:= 1;
          l_text:= Text;
          l_length:= Length(l_text);
          l_the_line:= '';
          l_index:= 1;
          l_start_index:= 0; l_line_number:= 0;
          while l_index<= l_length do
          begin
            if l_text[l_index]= k_return
              then begin
                 display(Format('%4d  %4d |', [l_start_index, l_line_number])+ l_the_line+ '|');

                 l_start_index:= l_index+ 1;
                 Inc(l_index, 2);
                 Inc(l_line_number);
                 l_the_line:= '';
                end
              else begin
                 l_the_line:= l_the_line+ l_text[l_index];
                 Inc(l_index);
               end;
          end;
          display(Format('%4d |', [l_start_index])+ l_the_line+ '|');
        end; // with p_c_memo
      end; // display_memo_with_index

    function f_memo_line_of_index(p_c_memo: tMemo; p_text_index: Integer): Integer;
      var l_line_index: Integer;
          l_running_text_index: Integer;
      begin
        Result:= 0;
        l_running_text_index:= 0;
        with p_c_memo do
          for l_line_index:= 0 to Lines.Count- 1 do
            if l_running_text_index> p_text_index
              then begin
                  Result:= l_line_index- 1;
                  Break;
                end
              else Inc(l_running_text_index, Length(Lines[l_line_index])+ 2);

      end; // f_memo_line_of_index

    procedure set_memo_top_line_index(p_c_memo: tMemo; p_top_line_index: Integer);
      var l_first_visible_line: Integer;
      begin
(*
          l_first_line_visible:= Perform(em_getfirstvisibleline,0,0);
          Form1.Caption:= IntToStr(l_first_line_visible);
          l_new_line:= 3;
          Perform(em_linescroll, 0, l_new_line- l_first_line_visible);
*)
        with p_c_memo do
        begin
          l_first_visible_line:= Perform(em_GetFirstVisibleLine, 0, 0);
          if l_first_visible_line<> p_top_line_index
            then Perform(em_LineScroll, 0, p_top_line_index- l_first_visible_line);
        end;
      end; // set_memo_top_line_index

    begin // u_dates
    end. // u_d
