// 002 u_whois_2
// 24 may 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_whois;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, FileCtrl
        , u_c_client_socket_4
        , u_c_whois_client_socket
        , u_c_whois_server_list_3
        , u_c_whois_searcher
  ;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    PageControl1: TPageControl;
    debug_: TTabSheet;
    result_: TTabSheet;
    Memo1: TMemo;
    result_memo_: TMemo;
    Panel4: TPanel;
    whois_server_domain_listbox_: TListBox;
    Panel3: TPanel;
    lookup_panel_: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    connect_panel_: TPanel;
    received_panel_: TPanel;
    whois_server_ip_label_: TLabel;
    Panel7: TPanel;
    search_domain_edit_: TEdit;
    search_: TButton;
    load_last_page_: TButton;
    PageControl2: TPageControl;
    ip_dns_: TTabSheet;
    dns_file_listbox_: TFileListBox;
    go_dns_: TButton;
    dns_ip_: TTabSheet;
    dns_ip_listbox_: TListBox;
    whois_server_: TTabSheet;
    whois_server_memo_: TMemo;
    Panel8: TPanel;
    display_server_list_: TButton;
    free_: TButton;
    search_url_list_: TTabSheet;
    Panel9: TPanel;
    load_url_list_: TButton;
    display_url_list_: TButton;
    save_url_list_: TButton;
    url_list_memo_: TMemo;
    url_list_file_name_edit_: TEdit;
    redisplay_info_: TTabSheet;
    info_listbox_: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure search_Click(Sender: TObject);
    procedure load_last_page_Click(Sender: TObject);
    procedure dns_file_listbox_Click(Sender: TObject);
    procedure go_dns_Click(Sender: TObject);
    procedure dns_ip_listbox_Click(Sender: TObject);
    procedure lookup_panel_Click(Sender: TObject);
    procedure whois_server_domain_listbox_Click(Sender: TObject);
    procedure display_server_list_Click(Sender: TObject);
    procedure free_Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure load_url_list_Click(Sender: TObject);
    procedure display_url_list_Click(Sender: TObject);
    procedure save_url_list_Click(Sender: TObject);
    procedure info_listbox_Click(Sender: TObject);
  private
    // -- c_whois_server_list
    procedure handle_after_create_whois_socket(p_c_whois_server_list: c_whois_server_list);
    procedure handle_after_lookup_whois_socket(p_c_whois_server_list: c_whois_server_list);
    procedure handle_after_changed_whois_server(p_c_whois_server_list: c_whois_server_list);

    // -- c_whois_searcher
    procedure handle_start_whois_search(p_c_whois_searcher: c_whois_searcher);
    procedure handle_after_whois_search_connect(p_c_whois_searcher: c_whois_searcher);
    procedure handle_after_whois_search_reception(p_c_whois_searcher: c_whois_searcher);
    procedure handle_after_whois_search_server_closed(p_c_whois_searcher: c_whois_searcher);

    function f_get_next_ip: String;
  public
  end;

    var Form1: TForm1;

  implementation
    uses u_types_constants
        , u_c_display, u_c_log
        , u_dir, u_file
        , u_exe
        , u_memo
        , u_strings
        , u_c_search_url_list
    ;

    {$R *.DFM}

     
  
    const k_whois_server_path= '..\_data\_servers\';
            k_whois_server_name= 'whois_servers.txt';
          k_search_dns_path= '..\_data\_search_dns\';

    var g_whois_server_name: String= '';
        g_whois_server_ip: String= '';
        g_c_traffic_log: c_log= Nil;
        g_c_request_log: c_log= Nil;

        g_c_search_url_list: c_search_url_list= Nil;

        g_c_whois_server_list: c_whois_server_list= Nil;
        g_c_whois_searcher: c_whois_searcher= Nil;

    procedure set_panel_color(p_c_panel: tPanel; p_color: Integer);
      begin
        p_c_panel.Color:= p_color;
        Application.ProcessMessages;
      end; // set_panel_color

    procedure load_whois_servers;
        // -- load the whois server domain name in the ListBox
      var l_list_index: Integer;
          l_the_line: String;
      begin
        Form1.whois_server_domain_listbox_.Items.Clear;
        with tStringList.Create do
        begin
          LoadFromFile(f_exe_path+ k_whois_server_path+ k_whois_server_name);

          for l_list_index:= 0 to Count- 1 do
          begin
            l_the_line:= Trim(Strings[l_list_index]);
            if l_the_line<> ''
              then begin
                  if (l_the_line[1]<> '/')
                    then Form1.whois_server_domain_listbox_.Items.Add(l_the_line);
                end
              else Form1.whois_server_domain_listbox_.Items.Add('');
          end; // while l_list_index

          Free;
        end; // with tStringList
      end; // load_whois_servers

    procedure TForm1.handle_after_create_whois_socket(p_c_whois_server_list: c_whois_server_list);
      begin
        // set_panel_color(lookup_panel_, clLime);
        set_panel_color(connect_panel_, clLime);
        set_panel_color(received_panel_, clRed);
      end; // handle_after_create_whois_socket

    procedure TForm1.handle_after_lookup_whois_socket(p_c_whois_server_list: c_whois_server_list);
      begin
        set_panel_color(connect_panel_, clRed);
        set_panel_color(received_panel_, clLime);

        with g_c_whois_server_list.m_c_current_whois_server, whois_server_memo_.Lines do
        begin
          // Add(Format('%-30s ', [m_whois_server_name])+ m_whois_server_ip);
          Add(Format('%-30s ', [m_name])+ m_ip);
          with whois_server_domain_listbox_ do
            ItemIndex:= Items.IndexOf(m_name);
        end;
      end; // handle_after_lookup_whois_socket

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        load_whois_servers;
        whois_server_domain_listbox_.ItemIndex:= 0;

        set_panel_color(lookup_panel_, clRed);
        set_panel_color(connect_panel_, clRed);
        set_panel_color(received_panel_, clRed);

        g_c_traffic_log:= c_log.create_log('traffic', f_exe_path+ 'log\whois_traffic_2.txt');
        g_c_request_log:= c_log.create_log('request', f_exe_path+ 'log\whois_request.txt');

        set_file_listbox_directory(dns_file_listbox_, f_exe_path+ k_search_dns_path);
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    // -- the whois part

    procedure TForm1.handle_after_changed_whois_server(p_c_whois_server_list: c_whois_server_list);
      begin
        with g_c_whois_server_list.m_c_current_whois_server do
        begin
          g_whois_server_name:= m_name;
          g_whois_server_ip:= m_ip;
        end; // with g_c_whois_server_list

        Caption:= g_whois_server_name;
        // -- display
        with Form1.whois_server_domain_listbox_ do
          ItemIndex:= Items.IndexOf(g_whois_server_name);
        Form1.whois_server_ip_label_.Caption:= g_whois_server_ip;
      end; // handle_after_changed_whois_server

    procedure TForm1.lookup_panel_Click(Sender: TObject);
      // -- search all the dns server ips
      begin
        // push_stop_display(1);
        g_c_whois_server_list:= c_whois_server_list.create_whois_server_list('whois');
           // f_exe_path+ k_whois_server_path+ 'whois_servers.txt');

        with g_c_whois_server_list do
        begin
          load_whois_servers(f_exe_path+ k_whois_server_path+ k_whois_server_name);
          load_keys(f_exe_path+ k_whois_server_path+ 'whois_server_keys.txt');
          // display_whois_server_list;

          // -- connect the events
          m_on_after_create_whois_socket:= handle_after_create_whois_socket;
          m_on_after_lookup_whois_socket:= handle_after_lookup_whois_socket;
          m_on_after_changed_whois_server:= handle_after_changed_whois_server;

          // -- find only once all the ips
          find_server_ips;
        end; // with g_c_whois_server_list
      end; // lookup_panel_Click

    procedure set_whois_server(p_whois_key: String);
        // -- update the display of a key "us" "europe"
      begin
        with g_c_whois_server_list do
        begin
          set_current_whois_server(p_whois_key);

          g_whois_server_name:= m_c_current_whois_server.m_name;
          g_whois_server_ip:= m_c_current_whois_server.m_ip;
        end; // with g_c_whois_server_list

        // -- display
        with Form1.whois_server_domain_listbox_ do
          ItemIndex:= Items.IndexOf(g_whois_server_name);
        Form1.whois_server_ip_label_.Caption:= g_whois_server_ip;
      end; // set_whois_server

    procedure TForm1.whois_server_domain_listbox_Click(Sender: TObject);
      var l_server_name, l_server_key: String;
      begin
        display('> whois_server_domain_listbox_Click');
        if g_c_whois_server_list= Nil
          then lookup_panel_Click(Nil);

        with whois_server_domain_listbox_ do
        begin
          l_server_name:= Items[ItemIndex];

          with g_c_whois_server_list do
          begin
            with f_c_find_by_whois_server_by_name(l_server_name) do
              l_server_key:= m_key;
            display(l_server_name+ ' '+ l_server_key);

            set_whois_server(l_server_key);
          end;
        end;
        display('< whois_server_domain_listbox_Click');
      end; // whois_server_domain_listbox_Click

    // -- the search part

    procedure TForm1.search_Click(Sender: TObject);
        // -- send the domain whois request
      begin
        display('> search_Click');
        set_panel_color(connect_panel_, clRed);
        set_panel_color(received_panel_, clRed);

        g_c_whois_searcher.Free;
        g_c_whois_searcher:= c_whois_searcher.create_whois_searcher('search',
            g_c_traffic_log, g_c_whois_server_list);


        with g_c_whois_searcher do
        begin
          m_c_request_log_ref:= g_c_request_log;
          m_on_after_whois_search_connect:= handle_after_whois_search_connect;
          m_on_start_whois_search:= handle_start_whois_search;
          m_on_after_whois_search_reception:= handle_after_whois_search_reception;
          m_on_after_whois_search_server_closed:= Self.handle_after_whois_search_server_closed;
          // m_on_after_whois_search_server_closed

          search(search_domain_edit_.Text);
        end; // with g_c_whois_searcher
        display('< search_Click');
      end; // search_Click

    procedure TForm1.handle_start_whois_search(p_c_whois_searcher: c_whois_searcher);
      begin
        clear_display;
        display_line;
        set_panel_color(connect_panel_, clRed);
        set_panel_color(received_panel_, clRed);

        with g_c_whois_searcher do
        begin
          search_domain_edit_.Text:= m_search_ip;
          Caption:= m_search_ip;
        end;
      end; // handle_start_whois_search

    procedure TForm1.handle_after_whois_search_connect(p_c_whois_searcher: c_whois_searcher);
      begin
        set_panel_color(connect_panel_, clLime);
      end; // TForm1.handle_after_whois_search_connect

    procedure TForm1.handle_after_whois_search_reception(p_c_whois_searcher: c_whois_searcher);
      begin
        display('> after_reception');
        set_panel_color(connect_panel_, clYellow);
        set_panel_color(received_panel_, clLime);

        display('< after_reception');
      end; // handle_after_whois_search_reception

    procedure TForm1.handle_after_whois_search_server_closed(p_c_whois_searcher: c_whois_searcher);
      var l_next_ip: String;
      begin
        display('> Form1.handle_after_whois_search_server_closed ');
        // -- display the last ifnormation in a memo
        load_last_page_Click(Nil);

        // -- save this name in the search_url_list
        with g_c_whois_searcher, g_c_search_url_list.f_c_find_by_search_url(m_search_ip) do
        begin
          m_whois_answer_file_name:= m_result_file_name;
          m_whois_server_key:= f_whois_server_key;

          // info_listbox_.Items.Add(m_result_file_name);
          info_listbox_.Items.Add(m_search_ip);
        end; // with g_c_whois_searcher

        l_next_ip:= f_get_next_ip;
        display('next_ip '+ l_next_ip+ '<');

        if l_next_ip<> ''
          then begin
              search_domain_edit_.Text:= l_next_ip;
              search_Click(Nil);
            end
          else ; // display_bug_stop('no_more_ip')  ;
        display('< Form1.handle_after_whois_search_server_closed');
      end; // handle_after_whois_search_server_closed

    procedure TForm1.load_last_page_Click(Sender: TObject);
      begin
        PageControl1.ActivePage:= result_;
        with g_c_whois_searcher do
          if FileExists(m_result_path+ m_result_file_name)
            then result_memo_.Lines.LoadFromFile(m_result_path+ m_result_file_name);
      end; // with g_c_whois_client_socket

    procedure TForm1.dns_ip_listbox_Click(Sender: TObject);
      begin
        display('> dns_ip_listbox_Click');
        with dns_ip_listbox_ do
          search_domain_edit_.Text:= Items[ItemIndex];
        search_Click(Nil);
        display('< dns_ip_listbox_Click');
      end; // dns_ip_listbox_Click

    procedure load_dns_file(p_full_file_name: String);
        // -- load file from log_dns
      var l_list_index: Integer;
          l_the_line: String;
          l_index: Integer;
          l_ip, l_domain: String;
          l_dot_count: Integer;
      begin
        g_c_search_url_list.Free;
        g_c_search_url_list:= c_search_url_list.create_search_url_list('search_url');

        with Form1, tStringList.Create do
        begin
          // check_path_and_name(p_full_file_name);
          
          LoadFromFile(p_full_file_name);

          for l_list_index:= 0 to Count- 1 do
          begin
            l_the_line:= Trim(Strings[l_list_index]);
            // display(l_the_line);
            if (l_the_line<> '') and (l_the_line[1]<> '/')
                and (l_the_line[1] in ['0'..'9'])
              then begin
                  l_index:= 1;
                  // f_string_extract_non_blank(l_the_line, l_index);
                  skip_blanks(l_the_line, l_index);

                  l_ip:= ''; l_dot_count:= 0;
                  while l_index<= Length(l_the_line) do
                  begin
                    // display(l_the_line[l_index]);
                    case l_the_line[l_index] of
                      '0'..'9' : begin
                                   l_ip:= l_ip+ l_the_line[l_index];
                                   Inc(l_index);
                                 end;
                      '.' : begin
                              l_ip:= l_ip+ l_the_line[l_index];
                              Inc(l_index);
                              Inc(l_dot_count);
                              skip_blanks(l_the_line, l_index);
                            end;
                      ' ' : begin
                              if l_dot_count= 3
                                then Break;
                              Inc(l_index);
                            end;
                    end; // case
                  end; // while

                  dns_ip_listbox_.Items.Add(l_ip);
                  l_domain:= f_string_extract_non_blank(l_the_line, l_index);

                  g_c_search_url_list.f_c_add_unique_search_url(l_ip, l_domain);
                end;
          end; // while l_list_index

          Free;
        end; // with tStringList

        g_c_search_url_list.display_search_url_list;
      end; // load_dns_file

    var // -- no longer used ??
        g_item_index: Integer= 0;

    function TForm1.f_get_next_ip: String;
      begin
        display('> f_get_next_ip '+ IntToStr(Form1.dns_ip_listbox_.ItemIndex));

        with Form1.dns_ip_listbox_ do
        begin
          Inc(g_item_index);

          if ItemIndex= Items.Count- 1
            then // stop('END')
            else begin
                ItemIndex:= ItemIndex+ 1;

                if g_item_index< Items.Count
                  then Result:= Items[ItemIndex]
                  else Result:= '';
             end;
          display('< f_get_next_ip '+ IntToStr(ItemIndex)+ ' '+ Result+ '<');
        end;
      end; // f_get_next_ip

    procedure TForm1.dns_file_listbox_Click(Sender: TObject);
      var l_file_name: String;
      begin
        display('> dns_file_listbox_Click');

        PageControl2.ActivePage:= dns_ip_;
        info_listbox_.Items.Clear;

        with dns_file_listbox_ do
        begin
          if Items.Count= 0
            then begin
                display_bug_stop('no_dns_file');
                Exit;
              end;
          if ItemIndex< 0
            then ItemIndex:= 0;
          l_file_name:= Items[ItemIndex];
          url_list_file_name_edit_.Text:= '_'+ l_file_name;
        end; // with dns_file_listbox_

        load_dns_file(f_exe_path+ k_search_dns_path+ l_file_name);

        if g_c_whois_server_list= Nil
          then Exit;
          
        // -- make sure the ip is initialized
        with g_c_whois_server_list.m_c_current_whois_server do
          if m_key= ''
            then set_whois_server('europe');

        // -- search the first dns
        with dns_ip_listbox_ do
        begin
          g_item_index:= -1;
          ItemIndex:= -1;
          f_get_next_ip;
          dns_ip_listbox_Click(Nil);
        end;
        display('< dns_file_listbox_Click');
      end; // dns_file_listbox_Click

    procedure TForm1.go_dns_Click(Sender: TObject);
      begin
        display('> go_dns_click');

        with dns_file_listbox_ do
        begin
          // -- our trial dns file is the second
          ItemIndex:= 2;
          // -- load the reverse dns file
          dns_file_listbox_Click(Nil);
        end;

        display('< go_dns_click');
      end; // go_dns_Click

    procedure TForm1.display_server_list_Click(Sender: TObject);
      begin
        if g_c_whois_server_list<> Nil
          then begin
              initialize_display(whois_server_memo_.Lines);
              clear_display;
              g_c_whois_server_list.display_whois_server_list;
              initialize_display(Memo1.Lines);
            end;
      end; // display_server_list_Click

    procedure TForm1.free_Click(Sender: TObject);
      begin
        g_c_display.Free;           g_c_display:= Nil;
        g_c_traffic_log.Free;       g_c_traffic_log:= Nil;
        g_c_request_log.Free;       g_c_request_log:= Nil;

        g_c_whois_server_list.Free; g_c_whois_server_list:= Nil;

        g_c_search_url_list.Free;   g_c_search_url_list:= Nil;
        g_c_whois_searcher.Free;    g_c_whois_searcher:= Nil;
      end; // free_Click

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        free_Click(Nil);
      end;

    procedure TForm1.load_url_list_Click(Sender: TObject);
      begin

      end; // load_url_list_Click

    procedure TForm1.display_url_list_Click(Sender: TObject);
      begin
        initialize_display(url_list_memo_.Lines);
        g_c_search_url_list.display_search_url_list;
        initialize_display(Memo1.Lines);
      end; // display_url_list_Click

    procedure TForm1.save_url_list_Click(Sender: TObject);
      begin
        g_c_search_url_list.save_to_file(f_exe_path+ '..\_data\_search_url_file\'+ url_list_file_name_edit_.Text);
      end; // save_url_list_Click

    procedure TForm1.info_listbox_Click(Sender: TObject);
        // -- load an information text back
      var l_file_name: String;
          l_full_file_name: String;
          l_ip: String;
      begin
        with info_listbox_, Items do
          l_ip:= Items[ItemIndex];
        search_domain_edit_.Text:= l_ip;  

        with g_c_search_url_list.f_c_find_by_search_url(l_ip) do
        begin
          g_c_whois_server_list.set_current_whois_server(m_whois_server_key);
          l_file_name:= m_whois_answer_file_name;
        end;

        l_full_file_name:= f_exe_path+ '..\_data\_result\'+ l_file_name;
        display(l_full_file_name);
        if FileExists(l_full_file_name)
          then
          else begin
              check_path_and_name(l_full_file_name);
              l_full_file_name:= '';
            end;

        if l_full_file_name<> ''
          then result_memo_.Lines.LoadFromFile(l_full_file_name);
      end; // info_listbox_Click

end.

